<?php

namespace App\Controller;

use App\Entity\Collectionner;
use App\Entity\Collectionneur;
use App\Entity\PieceModele;
use App\Repository\CollectionnerRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

#[Route('/collectionner')]
class CollectionnerController extends AbstractController
{
    #[Route('/', name: 'app_collectionner')]
    public function index(CollectionnerRepository $collectionnerRepository): Response
    {
        return $this->render('collectionner/index.html.twig', [
            'collectionners' => $collectionnerRepository->findAll(),
        ]);
    }

    #[Route('/insert', name: 'app_collectionner_insert')]
    public function insert(EntityManagerInterface $entityManager): Response
    {
        $pieceModele = $entityManager->getRepository(PieceModele::class)->find(1) ;
        $collectionneur = $entityManager->getRepository(Collectionneur::class)->find(1) ;

        $collectionner = new Collectionner() ;

        $collectionner->setPieceModeleID($pieceModele) ;
        $collectionner->setCollectionneurID($collectionneur) ;
        $collectionner->setQteCollection(512) ;

        $entityManager->persist($collectionner);
        $entityManager->flush();

        return $this->redirectToRoute('app_collectionner', [
            'id' => $collectionner->getId(),
        ], Response::HTTP_SEE_OTHER);
    }

    #[Route('/{id}', name: 'app_collectionner_show')]
    public function show(Collectionner $collectionner): Response
    {
        return $this->render('collectionner/show.html.twig', [
            'collectionner' => $collectionner,
        ]);
    }

    #[Route('/update/{id}', name: 'app_collectionner_update')]
    public function update(Collectionner $collectionner, EntityManagerInterface $entityManager): Response
    {
        $collectionner->setQteCollection(666) ;

        $entityManager->persist($collectionner);
        $entityManager->flush();

        return $this->render('collectionner/show.html.twig', [
            'collectionner' => $collectionner,
        ]);
    }

    #[Route('/delete/{id}', name: 'app_collectionner_delete')]
    public function delete(Collectionner $collectionner, EntityManagerInterface $entityManager): Response
    {
        $entityManager->remove($collectionner);
        $entityManager->flush();

        return $this->redirectToRoute('app_collectionner', [], Response::HTTP_SEE_OTHER);
    }
}
